<?php
/**
 * OrderFillableProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * OMS
 *
 * Управление заказами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\OmsClient\Dto;

use \ArrayAccess;
use \Ensi\OmsClient\ObjectSerializer;

/**
 * OrderFillableProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderFillableProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'OrderFillableProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'responsible_id' => 'int',
        'status' => 'int',
        'client_comment' => 'string',
        'receiver_name' => 'string',
        'receiver_phone' => 'string',
        'receiver_email' => 'string',
        'is_problem' => 'bool',
        'problem_comment' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'responsible_id' => null,
        'status' => null,
        'client_comment' => null,
        'receiver_name' => null,
        'receiver_phone' => null,
        'receiver_email' => null,
        'is_problem' => null,
        'problem_comment' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'responsible_id' => true,
        'status' => false,
        'client_comment' => true,
        'receiver_name' => true,
        'receiver_phone' => true,
        'receiver_email' => true,
        'is_problem' => true,
        'problem_comment' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'responsible_id' => 'responsible_id',
        'status' => 'status',
        'client_comment' => 'client_comment',
        'receiver_name' => 'receiver_name',
        'receiver_phone' => 'receiver_phone',
        'receiver_email' => 'receiver_email',
        'is_problem' => 'is_problem',
        'problem_comment' => 'problem_comment'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'responsible_id' => 'setResponsibleId',
        'status' => 'setStatus',
        'client_comment' => 'setClientComment',
        'receiver_name' => 'setReceiverName',
        'receiver_phone' => 'setReceiverPhone',
        'receiver_email' => 'setReceiverEmail',
        'is_problem' => 'setIsProblem',
        'problem_comment' => 'setProblemComment'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'responsible_id' => 'getResponsibleId',
        'status' => 'getStatus',
        'client_comment' => 'getClientComment',
        'receiver_name' => 'getReceiverName',
        'receiver_phone' => 'getReceiverPhone',
        'receiver_email' => 'getReceiverEmail',
        'is_problem' => 'getIsProblem',
        'problem_comment' => 'getProblemComment'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('responsible_id', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('client_comment', $data, null);
        $this->setIfExists('receiver_name', $data, null);
        $this->setIfExists('receiver_phone', $data, null);
        $this->setIfExists('receiver_email', $data, null);
        $this->setIfExists('is_problem', $data, null);
        $this->setIfExists('problem_comment', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets responsible_id
     *
     * @return int|null
     */
    public function getResponsibleId()
    {
        return $this->container['responsible_id'];
    }

    /**
     * Sets responsible_id
     *
     * @param int|null $responsible_id Идентификатор ответственного за заказ
     *
     * @return $this
     */
    public function setResponsibleId($responsible_id)
    {

        if (is_null($responsible_id)) {
            array_push($this->openAPINullablesSetToNull, 'responsible_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('responsible_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['responsible_id'] = $responsible_id;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status статус заказа из OrderStatus
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets client_comment
     *
     * @return string|null
     */
    public function getClientComment()
    {
        return $this->container['client_comment'];
    }

    /**
     * Sets client_comment
     *
     * @param string|null $client_comment комментарий клиента
     *
     * @return $this
     */
    public function setClientComment($client_comment)
    {

        if (is_null($client_comment)) {
            array_push($this->openAPINullablesSetToNull, 'client_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('client_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['client_comment'] = $client_comment;

        return $this;
    }

    /**
     * Gets receiver_name
     *
     * @return string|null
     */
    public function getReceiverName()
    {
        return $this->container['receiver_name'];
    }

    /**
     * Sets receiver_name
     *
     * @param string|null $receiver_name имя получателя
     *
     * @return $this
     */
    public function setReceiverName($receiver_name)
    {

        if (is_null($receiver_name)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_name'] = $receiver_name;

        return $this;
    }

    /**
     * Gets receiver_phone
     *
     * @return string|null
     */
    public function getReceiverPhone()
    {
        return $this->container['receiver_phone'];
    }

    /**
     * Sets receiver_phone
     *
     * @param string|null $receiver_phone телефон получателя
     *
     * @return $this
     */
    public function setReceiverPhone($receiver_phone)
    {

        if (is_null($receiver_phone)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_phone'] = $receiver_phone;

        return $this;
    }

    /**
     * Gets receiver_email
     *
     * @return string|null
     */
    public function getReceiverEmail()
    {
        return $this->container['receiver_email'];
    }

    /**
     * Sets receiver_email
     *
     * @param string|null $receiver_email e-mail получателя
     *
     * @return $this
     */
    public function setReceiverEmail($receiver_email)
    {

        if (is_null($receiver_email)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_email'] = $receiver_email;

        return $this;
    }

    /**
     * Gets is_problem
     *
     * @return bool|null
     */
    public function getIsProblem()
    {
        return $this->container['is_problem'];
    }

    /**
     * Sets is_problem
     *
     * @param bool|null $is_problem флаг, что заказ проблемный
     *
     * @return $this
     */
    public function setIsProblem($is_problem)
    {

        if (is_null($is_problem)) {
            array_push($this->openAPINullablesSetToNull, 'is_problem');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_problem', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_problem'] = $is_problem;

        return $this;
    }

    /**
     * Gets problem_comment
     *
     * @return string|null
     */
    public function getProblemComment()
    {
        return $this->container['problem_comment'];
    }

    /**
     * Sets problem_comment
     *
     * @param string|null $problem_comment последнее сообщение продавца о проблеме со сборкой
     *
     * @return $this
     */
    public function setProblemComment($problem_comment)
    {

        if (is_null($problem_comment)) {
            array_push($this->openAPINullablesSetToNull, 'problem_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('problem_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['problem_comment'] = $problem_comment;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


